#ifndef DYNCONSTRAINTOBJECT_H__
#define DYNCONSTRAINTOBJECT_H__

enum
{
	CONSTRAINT_JOINT_TYPE_COMPOUND = -1,
	CONSTRAINT_JOINT_TYPE_HINGE = 0,
	CONSTRAINT_JOINT_TYPE_CARDAN = 1,
	CONSTRAINT_JOINT_TYPE_BALLSOCKET = 2,
	CONSTRAINT_JOINT_TYPE_RAGDOLL = 3,
	CONSTRAINT_JOINT_TYPE_SLIDER = 4,
	CONSTRAINT_JOINT_TYPE_ROT_SLIDER = 5,
	CONSTRAINT_JOINT_TYPE_FIXED = 6,
	CONSTRAINT_JOINT_TYPE_PLANAR = 7,
	CONSTRAINT_JOINT_TYPE_BOX = 8,
	CONSTRAINT_JOINT_TYPE_WHEEL = 9,

	CONSTRAINT_IGNORE_COLLISIONS = 12311,
	CONSTRAINT_LIMIT_RESTITUTION = 12312,

	CONSTRAINT_ROT1_LIMIT = 12401,
	CONSTRAINT_ROT1_LIMIT_MIN = 12402,
	CONSTRAINT_ROT1_LIMIT_MAX = 12403,
	CONSTRAINT_ROT1_USE_BREAKING_TORQUE = 12404,
	CONSTRAINT_ROT1_BREAKING_TORQUE = 12405,
	CONSTRAINT_ROT2_LIMIT = 12411,
	CONSTRAINT_ROT2_LIMIT_MIN = 12412,
	CONSTRAINT_ROT2_LIMIT_MAX = 12413,
	CONSTRAINT_CONE_LIMIT_RADIUS = 12421,
	CONSTRAINT_CONE_LIMIT_ELLIPTICAL = 12422,
	CONSTRAINT_CONE_LIMIT_RADIUS2 = 12423,
	CONSTRAINT_WHEEL_ANGLE = 12424,
	CONSTRAINT_WHEEL_REST_POSITION = 12425,
	CONSTRAINT_WHEEL_STIFFNESS = 12426,
	CONSTRAINT_WHEEL_DAMPING = 12427,

	CONSTRAINT_TRANS1_LIMIT_USE_MIN = 12431,
	CONSTRAINT_TRANS1_LIMIT_MIN = 12432,
	CONSTRAINT_TRANS1_LIMIT_USE_MAX = 12433,
	CONSTRAINT_TRANS1_LIMIT_MAX = 12434,
	CONSTRAINT_TRANS1_USE_BREAKING_FORCE = 12435,
	CONSTRAINT_TRANS1_BREAKING_FORCE = 12436,
	CONSTRAINT_TRANS2_LIMIT_USE_MIN = 12441,
	CONSTRAINT_TRANS2_LIMIT_MIN = 12442,
	CONSTRAINT_TRANS2_LIMIT_USE_MAX = 12443,
	CONSTRAINT_TRANS2_LIMIT_MAX = 12444,
	CONSTRAINT_TRANS3_LIMIT_USE_MIN = 12451,
	CONSTRAINT_TRANS3_LIMIT_MIN = 12452,
	CONSTRAINT_TRANS3_LIMIT_USE_MAX = 12453,
	CONSTRAINT_TRANS3_LIMIT_MAX = 12454,

	CONSTRAINT_GROUP_CACHE = 12490,
	CONSTRAINT_CACHE_LOCAL = 12491,
	CONSTRAINT_CACHE_USE = 12492,
	CONSTRAINT_CACHE_CLEAR = 12493,
	CONSTRAINT_CACHE_MEMORY = 12499,

	CONSTRAINT_DUMMY
};

#endif // DYNCONSTRAINTOBJECT_H__
